<template>
  <div class="order-request-execution">
    <ObForm
      :form-model="formModel"
      :form-data="formData"
      ok-text="Добавить"
      :is-loading="isLoading"
      data-qa="addClientCostReductionModal"
      @submit="onSubmitHandler"
    >
      <ObSelect
        v-model="formData.clientUuid"
        label="Выбрать клиента"
        placeholder="Выберите"
        :remote-opt="getClients"
        :is-search="true"
        class="mb20"
        data-qa="addCostReductionClientsList"
      />
      <template v-if="formData.costReductions">
        <div class="settings-row">
          <div class="settings-row__item --left">
            <div class="title">FTL гор. доставка</div>
            <ObInput
              v-model.number="formData.costReductions.ftlUrban"
              label="Скидка лимита"
              placeholder="—"
              sub-title="%"
              type="money:1"
              :is-convert-money="false"
              @blur="onBlurField('ftlUrban')"
            />
          </div>
          <div class="settings-row__item --right">
            <div class="title">Магистралка контейнеры</div>
            <ObInput
              v-model.number="formData.costReductions.mainlineContainer"
              label="Скидка лимита"
              placeholder="—"
              sub-title="%"
              type="money:1"
              :is-convert-money="false"
              @blur="onBlurField('mainlineContainer')"
            />
          </div>
        </div>
        <div class="settings-row">
          <div class="settings-row__item --left">
            <div class="title">FTL межгород</div>
            <ObInput
              v-model.number="formData.costReductions.ftlInterurban"
              label="Скидка лимита"
              placeholder="—"
              sub-title="%"
              type="money:1"
              :is-convert-money="false"
              @blur="onBlurField('ftlInterurban')"
            />
          </div>
          <div class="settings-row__item --right">
            <div class="title">Магистралка вагоны</div>
            <ObInput
              v-model.number="formData.costReductions.mainlineRail"
              label="Скидка лимита"
              placeholder="—"
              sub-title="%"
              type="money:1"
              :is-convert-money="false"
              @blur="onBlurField('mainlineRail')"
            />
          </div>
        </div>
        <div class="settings-row">
          <div class="settings-row__item --left">
            <div class="title">FTL международные автоперевозки</div>
            <ObInput
              v-model.number="formData.costReductions.ftlInternational"
              label="Скидка лимита"
              placeholder="—"
              sub-title="%"
              type="money:1"
              :is-convert-money="false"
              @blur="onBlurField('ftlInternational')"
            />
          </div>
          <div class="settings-row__item --right">
            <div class="title">Заказы “Отправить груз” для значений БЦ с полным доверием</div>
            <ObInput
              v-model.number="formData.costReductions.fullTrustOrder"
              label="Скидка лимита"
              placeholder="—"
              sub-title="%"
              type="money:1"
              :is-convert-money="false"
              @blur="onBlurField('fullTrustOrder')"
            />
          </div>
        </div>
        <div class="settings-row">
          <div class="settings-row__item --left">
            <div class="title">Мультимодальные автоплечи</div>
            <ObInput
              v-model.number="formData.costReductions.multimodalAuto"
              label="Скидка лимита"
              placeholder="—"
              sub-title="%"
              type="money:1"
              :is-convert-money="false"
              @blur="onBlurField('multimodalAuto')"
            />
          </div>
          <div class="settings-row__item --right">
            <div class="title">Заказы “Отправить груз” для значений БЦ с частичным доверием</div>
            <ObInput
              v-model.number="formData.costReductions.partialTrustOrder"
              label="Скидка лимита"
              placeholder="—"
              sub-title="%"
              type="money:1"
              :is-convert-money="false"
              @blur="onBlurField('partialTrustOrder')"
            />
          </div>
        </div>
      </template>
    </ObForm>
  </div>
</template>

<script>
import api from '@/api'
import ObForm from 'common-components/src/obComponents/obForm'
import ObInput from 'common-components/src/obComponents/obInput'
import ObSelect from 'common-components/src/obComponents/obSelect'
import FormValidationMixin from 'common-components/src/obComponents/obForm/FormValidationMixin'
import { required, requiredIf } from 'vuelidate/lib/validators'

const minValue = -100
const maxValue = 25

export default {
  name: 'AddClientCostReductionModal',
  mixins: [
    FormValidationMixin
  ],
  components: {
    ObForm,
    ObInput,
    ObSelect
  },
  data () {
    return {
      isLoading: false
    }
  },
  computed: {
    isValidOneField () {
      return Object.values(this.formData?.costReductions || {}).some(value => value || value === 0)
    },
    formModel () {
      const _self = this
      const dataSource = this.dataSource

      return {
        clientUuid: {
          value: '',
          validator: {
            required
          }
        },
        costReductions: {
          validator: {
            isNotDefaultCostReductions: _self.isNotDefaultCostReductions
          },
          nested_fields: {
            ftlUrban: {
              value: () => dataSource.ftlUrban,
              validator: {
                required: requiredIf(function () {
                  return !_self.isValidOneField
                })
              }
            },
            ftlInterurban: {
              value: () => dataSource.ftlInterurban,
              validator: {
                required: requiredIf(function () {
                  return !_self.isValidOneField
                })
              }
            },
            ftlInternational: {
              value: () => dataSource.ftlInternational,
              validator: {
                required: requiredIf(function () {
                  return !_self.isValidOneField
                })
              }
            },
            multimodalAuto: {
              value: () => dataSource.multimodalAuto,
              validator: {
                required: requiredIf(function () {
                  return !_self.isValidOneField
                })
              }
            },
            mainlineContainer: {
              value: () => dataSource.mainlineContainer,
              validator: {
                required: requiredIf(function () {
                  return !_self.isValidOneField
                })
              }
            },
            mainlineRail: {
              value: () => dataSource.mainlineRail,
              validator: {
                required: requiredIf(function () {
                  return !_self.isValidOneField
                })
              }
            },
            fullTrustOrder: {
              value: () => dataSource.fullTrustOrder,
              validator: {
                required: requiredIf(function () {
                  return !_self.isValidOneField
                })
              }
            },
            partialTrustOrder: {
              value: () => dataSource.partialTrustOrder,
              validator: {
                required: requiredIf(function () {
                  return !_self.isValidOneField
                })
              }
            }
          }
        }
      }
    }
  },
  methods: {
    isNotDefaultCostReductions () {
      return JSON.stringify(this.dataSource) !== JSON.stringify(this.formData.costReductions || {})
    },
    async getClients ({ page, query }) {
      return await api.clicar_setting_3.getClientsList({ page, query })
    },
    onBlurField (key) {
      this.$nextTick(() => {
        if (this.formData.costReductions[key] < minValue) {
          this.formData.costReductions[key] = minValue
        }
        if (this.formData.costReductions[key] > maxValue) {
          this.formData.costReductions[key] = maxValue
        }
      })
    },
    async onSubmitHandler (data) {
      try {
        this.isLoading = true

        let result = {}

        for (let key in data.costReductions) {
          if (data.costReductions[key] || data.costReductions[key] === 0) {
            result[key] = data.costReductions[key]
          }
        }

        await api.clicar_setting_3.setCostReductionClientSettings({ clientUuid: data.clientUuid, costReductions: result })

        this.$emit('on-submitted')
        this.$notification({
          type: 'system_notification_success',
          message: 'Наценка добавлена'
        })
      } catch (e) {
        this.$notification({
          type: 'system_notification_error',
          message: 'Не удалось добавить наценку'
        })
      } finally {
        this.isLoading = false
      }
    }
  }
}
</script>

<style lang="scss" scoped>
@import "~common-components/src/static/css/mixins";

.settings-row {
  display: flex;
  &__item {
    &.--left {
      width: 320px;
    }
    &.--right {
      flex-grow: 2;
    }
    .title {
      margin-top: 30px;
      margin-bottom: 10px;
      @include font-mixin(16px, 20px, 700, $color-text-base, .4px);
    }
    &::v-deep {
      .ob-input-container {
        margin-top: 10px;
        width: 180px;
      }
    }
  }
}
</style>
